unit MFColorPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
 TBtnSelect = procedure(Color : TColor) of object;

type
  TColorPanel = class(TCustomPanel)
  private
    Image : TImage;
    FRightSelect,FLeftSelect,FChange : TBtnSelect;
    ColorSelected : TColor;
  protected
    procedure Resize; override;
    procedure DoSelect(Sender: TObject;Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
    procedure DoChange(Sender: TObject; Shift: TShiftState;X, Y: Integer);
  public
    constructor Create(AOwner : TComponent); override;
  published
    Property Enabled;
    Property Visible;
    property OnLeftSelect : TBtnSelect read FLeftSelect write FLeftSelect;
    property OnRightSelect : TBtnSelect read FRightSelect write FRightSelect;
    property OnNewColor : TBtnSelect read FChange write FChange;
  end;

procedure Register;

implementation

{$R MFColorPanel}
const
 TheCursor = 5001;

procedure Register;
begin
  RegisterComponents('MicroFrame', [TColorPanel]);
end;

constructor TColorPanel.Create(AOwner : TComponent);
begin
 inherited Create(Aowner);
 Screen.Cursors[TheCursor] := LoadCursor(hInstance, pChar('CPICKER'));
 Width := 80;
 Height := 101;
 BevelInner:=bvLowered;
 BevelOuter:=bvRaised;
 BorderStyle := bsSingle;

 Image := TImage.Create(self);
 Image.Parent := self;
 Image.Align := alClient;
 Image.Cursor := TheCursor;
 Image.Picture.Bitmap.LoadFromResourceName(hInstance,'CCLRPANEL');
 Image.OnMouseDown := DoSelect;
 Image.OnMouseMove := DoChange;
end;

procedure TColorPanel.DoSelect(Sender: TObject;Button: TMouseButton;
                       Shift: TShiftState; X, Y: Integer);
begin
  ColorSelected := Image.Canvas.Pixels[x,y];
  if Button = mbLeft then begin
   if Assigned(FLeftSelect) then FLeftSelect(ColorSelected);
  end;
  if Button = mbRight then begin
   if Assigned(FRightSelect) then FRightSelect(ColorSelected);
  end;
end;

procedure TColorPanel.DoChange(Sender: TObject; Shift: TShiftState;X, Y: Integer);
begin
 ColorSelected := Image.Canvas.Pixels[x,y];
 if Assigned(FChange) then FChange(ColorSelected);
end;

procedure TColorPanel.Resize;
begin
 if Width <> 80 then Width := 80;
 if Height <> 101 then Height := 101;
end;


end.
